/* logger.c generated by valac 0.56.17, the Vala compiler
 * generated from logger.vala, do not modify */

/* Copyright 2023-2024 Rirusha
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, version 3
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: GPL-3.0-only
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <libsoup/soup.h>
#include <stdio.h>
#include <gobject/gvaluecollector.h>

#define CASSETTE_CLIENT_LOGGER_TIME_PREFIX "*TIME*   "
#define CASSETTE_CLIENT_LOGGER_SYSTEM_PREFIX "*SYSTEM* "
#define CASSETTE_CLIENT_LOGGER_BODY_IN_PREFIX "*BODY* <"
#define CASSETTE_CLIENT_LOGGER_IN_PREFIX "*IN*   <"
#define CASSETTE_CLIENT_LOGGER_BODY_OUT_PREFIX "*BODY* >"
#define CASSETTE_CLIENT_LOGGER_OUT_PREFIX "*OUT*  >"
#define CASSETTE_CLIENT_LOGGER_DEBUG_PREFIX "*DEBUG*  "
#define CASSETTE_CLIENT_LOGGER_DEVEL_PREFIX "*DEVEL*  "
#define CASSETTE_CLIENT_LOGGER_INFO_PREFIX "*INFO*   "
#define CASSETTE_CLIENT_LOGGER_WARNING_PREFIX "*WARNING*"
#define CASSETTE_CLIENT_LOGGER_ERROR_PREFIX "*ERROR*  "
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	CASSETTE_CLIENT_LOG_LEVEL_DEVEL,
	CASSETTE_CLIENT_LOG_LEVEL_DEBUG,
	CASSETTE_CLIENT_LOG_LEVEL_USER,
	CASSETTE_CLIENT_LOG_LEVEL_NONE
} CassetteClientLogLevel;

#define CASSETTE_CLIENT_TYPE_LOG_LEVEL (cassette_client_log_level_get_type ())

#define CASSETTE_CLIENT_TYPE_LOGGER (cassette_client_logger_get_type ())
#define CASSETTE_CLIENT_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), CASSETTE_CLIENT_TYPE_LOGGER, CassetteClientLogger))
#define CASSETTE_CLIENT_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), CASSETTE_CLIENT_TYPE_LOGGER, CassetteClientLoggerClass))
#define CASSETTE_CLIENT_IS_LOGGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), CASSETTE_CLIENT_TYPE_LOGGER))
#define CASSETTE_CLIENT_IS_LOGGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), CASSETTE_CLIENT_TYPE_LOGGER))
#define CASSETTE_CLIENT_LOGGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), CASSETTE_CLIENT_TYPE_LOGGER, CassetteClientLoggerClass))

typedef struct _CassetteClientLogger CassetteClientLogger;
typedef struct _CassetteClientLoggerClass CassetteClientLoggerClass;
typedef struct _CassetteClientLoggerPrivate CassetteClientLoggerPrivate;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _CassetteClientParamSpecLogger CassetteClientParamSpecLogger;

struct _CassetteClientLogger {
	GTypeInstance parent_instance;
	volatile int ref_count;
	CassetteClientLoggerPrivate * priv;
};

struct _CassetteClientLoggerClass {
	GTypeClass parent_class;
	void (*finalize) (CassetteClientLogger *self);
};

struct _CassetteClientParamSpecLogger {
	GParamSpec parent_instance;
};

static gpointer cassette_client_logger_parent_class = NULL;
static CassetteClientLogLevel cassette_client_logger__log_level;
static CassetteClientLogLevel cassette_client_logger__log_level = CASSETTE_CLIENT_LOG_LEVEL_USER;
static GFile* cassette_client_logger__log_file;
static GFile* cassette_client_logger__log_file = NULL;

VALA_EXTERN GType cassette_client_log_level_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gpointer cassette_client_logger_ref (gpointer instance);
VALA_EXTERN void cassette_client_logger_unref (gpointer instance);
VALA_EXTERN GParamSpec* cassette_client_param_spec_logger (const gchar* name,
                                               const gchar* nick,
                                               const gchar* blurb,
                                               GType object_type,
                                               GParamFlags flags);
VALA_EXTERN void cassette_client_value_set_logger (GValue* value,
                                       gpointer v_object);
VALA_EXTERN void cassette_client_value_take_logger (GValue* value,
                                        gpointer v_object);
VALA_EXTERN gpointer cassette_client_value_get_logger (const GValue* value);
VALA_EXTERN GType cassette_client_logger_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CassetteClientLogger, cassette_client_logger_unref)
static void cassette_client_logger_write_to_file (const gchar* log_level_str,
                                           const gchar* message);
VALA_EXTERN GFile* cassette_client_logger_get_log_file (void);
static void cassette_client_logger_write_net_to_file (const gchar* direction,
                                               const gchar* data);
VALA_EXTERN void cassette_client_logger_time (void);
VALA_EXTERN void cassette_client_logger_net_in (SoupLoggerLogLevel soup_log_level,
                                    const gchar* data);
VALA_EXTERN void cassette_client_logger_net_out (SoupLoggerLogLevel soup_log_level,
                                     const gchar* data);
VALA_EXTERN void cassette_client_logger_debug (const gchar* message);
VALA_EXTERN CassetteClientLogLevel cassette_client_logger_get_log_level (void);
VALA_EXTERN void cassette_client_logger_devel (const gchar* message);
VALA_EXTERN void cassette_client_logger_info (const gchar* message);
VALA_EXTERN void cassette_client_logger_warning (const gchar* message);
VALA_EXTERN void cassette_client_logger_error (const gchar* message);
VALA_EXTERN CassetteClientLogger* cassette_client_logger_new (void);
VALA_EXTERN CassetteClientLogger* cassette_client_logger_construct (GType object_type);
VALA_EXTERN void cassette_client_logger_set_log_level (CassetteClientLogLevel value);
VALA_EXTERN void cassette_client_logger_set_log_file (GFile* value);
static void cassette_client_logger_finalize (CassetteClientLogger * obj);
static GType cassette_client_logger_get_type_once (void);

 G_GNUC_NO_INLINE static GType
cassette_client_log_level_get_type_once (void)
{
	static const GEnumValue values[] = {{CASSETTE_CLIENT_LOG_LEVEL_DEVEL, "CASSETTE_CLIENT_LOG_LEVEL_DEVEL", "devel"}, {CASSETTE_CLIENT_LOG_LEVEL_DEBUG, "CASSETTE_CLIENT_LOG_LEVEL_DEBUG", "debug"}, {CASSETTE_CLIENT_LOG_LEVEL_USER, "CASSETTE_CLIENT_LOG_LEVEL_USER", "user"}, {CASSETTE_CLIENT_LOG_LEVEL_NONE, "CASSETTE_CLIENT_LOG_LEVEL_NONE", "none"}, {0, NULL, NULL}};
	GType cassette_client_log_level_type_id;
	cassette_client_log_level_type_id = g_enum_register_static ("CassetteClientLogLevel", values);
	return cassette_client_log_level_type_id;
}

GType
cassette_client_log_level_get_type (void)
{
	static gsize cassette_client_log_level_type_id__once = 0;
	if (g_once_init_enter (&cassette_client_log_level_type_id__once)) {
		GType cassette_client_log_level_type_id;
		cassette_client_log_level_type_id = cassette_client_log_level_get_type_once ();
		g_once_init_leave (&cassette_client_log_level_type_id__once, cassette_client_log_level_type_id);
	}
	return cassette_client_log_level_type_id__once;
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
#line 1609 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1610 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1610 "glib-2.0.vapi"
	res_length1 = -1;
#line 1610 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1611 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1611 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1611 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1612 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1612 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1612 "glib-2.0.vapi"
	if (result_length1) {
#line 1612 "glib-2.0.vapi"
		*result_length1 = _tmp2__length1;
#line 200 "logger.c"
	}
#line 1612 "glib-2.0.vapi"
	result = _tmp2_;
#line 1612 "glib-2.0.vapi"
	return result;
#line 206 "logger.c"
}

static void
cassette_client_logger_write_to_file (const gchar* log_level_str,
                                      const gchar* message)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 97 "../src/client/logger.vala"
	g_return_if_fail (log_level_str != NULL);
#line 98 "../src/client/logger.vala"
	_tmp0_ = cassette_client_logger_get_log_file ();
#line 98 "../src/client/logger.vala"
	_tmp1_ = _tmp0_;
#line 98 "../src/client/logger.vala"
	if (_tmp1_ == NULL) {
#line 99 "../src/client/logger.vala"
		return;
#line 226 "logger.c"
	}
	{
		GFileOutputStream* os = NULL;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileOutputStream* _tmp4_;
		gchar* current_time = NULL;
		GTimeZone* _tmp5_;
		GTimeZone* _tmp6_;
		GDateTime* _tmp7_;
		GDateTime* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* final_message = NULL;
		GFileOutputStream* _tmp14_;
		const gchar* _tmp15_;
		guint8* _tmp16_;
		gint _tmp16__length1;
		gint _tmp17_ = 0;
		guint8* _tmp18_;
		gint _tmp18__length1;
#line 103 "../src/client/logger.vala"
		_tmp2_ = cassette_client_logger_get_log_file ();
#line 103 "../src/client/logger.vala"
		_tmp3_ = _tmp2_;
#line 103 "../src/client/logger.vala"
		_tmp4_ = g_file_append_to (_tmp3_, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 103 "../src/client/logger.vala"
		os = _tmp4_;
#line 103 "../src/client/logger.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 258 "logger.c"
			goto __catch0_g_error;
		}
#line 104 "../src/client/logger.vala"
		_tmp5_ = g_time_zone_new_local ();
#line 104 "../src/client/logger.vala"
		_tmp6_ = _tmp5_;
#line 104 "../src/client/logger.vala"
		_tmp7_ = g_date_time_new_now (_tmp6_);
#line 104 "../src/client/logger.vala"
		_tmp8_ = _tmp7_;
#line 104 "../src/client/logger.vala"
		_tmp9_ = g_date_time_format (_tmp8_, "%T.%f");
#line 104 "../src/client/logger.vala"
		_tmp10_ = _tmp9_;
#line 104 "../src/client/logger.vala"
		_g_date_time_unref0 (_tmp8_);
#line 104 "../src/client/logger.vala"
		_g_time_zone_unref0 (_tmp6_);
#line 104 "../src/client/logger.vala"
		current_time = _tmp10_;
#line 107 "../src/client/logger.vala"
		if (message != NULL) {
#line 281 "logger.c"
			const gchar* _tmp11_;
			gchar* _tmp12_;
#line 108 "../src/client/logger.vala"
			_tmp11_ = current_time;
#line 108 "../src/client/logger.vala"
			_tmp12_ = g_strdup_printf ("%s : %s : %s\n", log_level_str, _tmp11_, message);
#line 108 "../src/client/logger.vala"
			_g_free0 (final_message);
#line 108 "../src/client/logger.vala"
			final_message = _tmp12_;
#line 292 "logger.c"
		} else {
			gchar* _tmp13_;
#line 114 "../src/client/logger.vala"
			_tmp13_ = g_strdup ("\n");
#line 114 "../src/client/logger.vala"
			_g_free0 (final_message);
#line 114 "../src/client/logger.vala"
			final_message = _tmp13_;
#line 301 "logger.c"
		}
#line 117 "../src/client/logger.vala"
		_tmp14_ = os;
#line 117 "../src/client/logger.vala"
		_tmp15_ = final_message;
#line 117 "../src/client/logger.vala"
		_tmp16_ = string_get_data (_tmp15_, &_tmp17_);
#line 117 "../src/client/logger.vala"
		_tmp16__length1 = _tmp17_;
#line 117 "../src/client/logger.vala"
		_tmp18_ = _tmp16_;
#line 117 "../src/client/logger.vala"
		_tmp18__length1 = _tmp16__length1;
#line 117 "../src/client/logger.vala"
		g_output_stream_write ((GOutputStream*) _tmp14_, _tmp18_, (gsize) _tmp18__length1, NULL, &_inner_error0_);
#line 117 "../src/client/logger.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 117 "../src/client/logger.vala"
			_g_free0 (final_message);
#line 117 "../src/client/logger.vala"
			_g_free0 (current_time);
#line 117 "../src/client/logger.vala"
			_g_object_unref0 (os);
#line 325 "logger.c"
			goto __catch0_g_error;
		}
#line 102 "../src/client/logger.vala"
		_g_free0 (final_message);
#line 102 "../src/client/logger.vala"
		_g_free0 (current_time);
#line 102 "../src/client/logger.vala"
		_g_object_unref0 (os);
#line 334 "logger.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 102 "../src/client/logger.vala"
		e = _inner_error0_;
#line 102 "../src/client/logger.vala"
		_inner_error0_ = NULL;
#line 120 "../src/client/logger.vala"
		_tmp19_ = e;
#line 120 "../src/client/logger.vala"
		_tmp20_ = _tmp19_->message;
#line 120 "../src/client/logger.vala"
		_tmp21_ = g_strdup_printf ("Can't write to log file. Error message: %s", _tmp20_);
#line 120 "../src/client/logger.vala"
		_tmp22_ = _tmp21_;
#line 120 "../src/client/logger.vala"
		g_warning ("logger.vala:120: %s", _tmp22_);
#line 120 "../src/client/logger.vala"
		_g_free0 (_tmp22_);
#line 102 "../src/client/logger.vala"
		_g_error_free0 (e);
#line 362 "logger.c"
	}
	__finally0:
#line 102 "../src/client/logger.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 102 "../src/client/logger.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 102 "../src/client/logger.vala"
		g_clear_error (&_inner_error0_);
#line 102 "../src/client/logger.vala"
		return;
#line 373 "logger.c"
	}
}

static void
cassette_client_logger_write_net_to_file (const gchar* direction,
                                          const gchar* data)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 124 "../src/client/logger.vala"
	g_return_if_fail (direction != NULL);
#line 124 "../src/client/logger.vala"
	g_return_if_fail (data != NULL);
#line 125 "../src/client/logger.vala"
	_tmp0_ = cassette_client_logger_get_log_file ();
#line 125 "../src/client/logger.vala"
	_tmp1_ = _tmp0_;
#line 125 "../src/client/logger.vala"
	if (_tmp1_ == NULL) {
#line 126 "../src/client/logger.vala"
		return;
#line 396 "logger.c"
	}
	{
		GFileOutputStream* os = NULL;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileOutputStream* _tmp4_;
		gchar* final_message = NULL;
		gchar* _tmp5_;
		GFileOutputStream* _tmp6_;
		const gchar* _tmp7_;
		guint8* _tmp8_;
		gint _tmp8__length1;
		gint _tmp9_ = 0;
		guint8* _tmp10_;
		gint _tmp10__length1;
#line 130 "../src/client/logger.vala"
		_tmp2_ = cassette_client_logger_get_log_file ();
#line 130 "../src/client/logger.vala"
		_tmp3_ = _tmp2_;
#line 130 "../src/client/logger.vala"
		_tmp4_ = g_file_append_to (_tmp3_, G_FILE_CREATE_NONE, NULL, &_inner_error0_);
#line 130 "../src/client/logger.vala"
		os = _tmp4_;
#line 130 "../src/client/logger.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 422 "logger.c"
			goto __catch0_g_error;
		}
#line 131 "../src/client/logger.vala"
		_tmp5_ = g_strdup_printf ("%s : %s\n", direction, data);
#line 131 "../src/client/logger.vala"
		final_message = _tmp5_;
#line 135 "../src/client/logger.vala"
		_tmp6_ = os;
#line 135 "../src/client/logger.vala"
		_tmp7_ = final_message;
#line 135 "../src/client/logger.vala"
		_tmp8_ = string_get_data (_tmp7_, &_tmp9_);
#line 135 "../src/client/logger.vala"
		_tmp8__length1 = _tmp9_;
#line 135 "../src/client/logger.vala"
		_tmp10_ = _tmp8_;
#line 135 "../src/client/logger.vala"
		_tmp10__length1 = _tmp8__length1;
#line 135 "../src/client/logger.vala"
		g_output_stream_write ((GOutputStream*) _tmp6_, _tmp10_, (gsize) _tmp10__length1, NULL, &_inner_error0_);
#line 135 "../src/client/logger.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 135 "../src/client/logger.vala"
			_g_free0 (final_message);
#line 135 "../src/client/logger.vala"
			_g_object_unref0 (os);
#line 449 "logger.c"
			goto __catch0_g_error;
		}
#line 129 "../src/client/logger.vala"
		_g_free0 (final_message);
#line 129 "../src/client/logger.vala"
		_g_object_unref0 (os);
#line 456 "logger.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 129 "../src/client/logger.vala"
		e = _inner_error0_;
#line 129 "../src/client/logger.vala"
		_inner_error0_ = NULL;
#line 137 "../src/client/logger.vala"
		_tmp11_ = e;
#line 137 "../src/client/logger.vala"
		_tmp12_ = _tmp11_->message;
#line 137 "../src/client/logger.vala"
		_tmp13_ = g_strdup_printf ("Can't write to log file. Error message: %s", _tmp12_);
#line 137 "../src/client/logger.vala"
		_tmp14_ = _tmp13_;
#line 137 "../src/client/logger.vala"
		g_warning ("logger.vala:137: %s", _tmp14_);
#line 137 "../src/client/logger.vala"
		_g_free0 (_tmp14_);
#line 129 "../src/client/logger.vala"
		_g_error_free0 (e);
#line 484 "logger.c"
	}
	__finally0:
#line 129 "../src/client/logger.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 129 "../src/client/logger.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 129 "../src/client/logger.vala"
		g_clear_error (&_inner_error0_);
#line 129 "../src/client/logger.vala"
		return;
#line 495 "logger.c"
	}
}

void
cassette_client_logger_time (void)
{
#line 142 "../src/client/logger.vala"
	cassette_client_logger_write_to_file (CASSETTE_CLIENT_LOGGER_TIME_PREFIX, "\n\n");
#line 504 "logger.c"
}

void
cassette_client_logger_net_in (SoupLoggerLogLevel soup_log_level,
                               const gchar* data)
{
	gboolean _tmp0_ = FALSE;
#line 145 "../src/client/logger.vala"
	g_return_if_fail (data != NULL);
#line 146 "../src/client/logger.vala"
	if (soup_log_level == SOUP_LOGGER_LOG_BODY) {
#line 146 "../src/client/logger.vala"
		_tmp0_ = g_strcmp0 (data, "") != 0;
#line 518 "logger.c"
	} else {
#line 146 "../src/client/logger.vala"
		_tmp0_ = FALSE;
#line 522 "logger.c"
	}
#line 146 "../src/client/logger.vala"
	if (_tmp0_) {
#line 147 "../src/client/logger.vala"
		cassette_client_logger_write_net_to_file (CASSETTE_CLIENT_LOGGER_BODY_IN_PREFIX, data);
#line 528 "logger.c"
	} else {
#line 149 "../src/client/logger.vala"
		cassette_client_logger_write_net_to_file (CASSETTE_CLIENT_LOGGER_IN_PREFIX, data);
#line 532 "logger.c"
	}
}

void
cassette_client_logger_net_out (SoupLoggerLogLevel soup_log_level,
                                const gchar* data)
{
	gboolean _tmp0_ = FALSE;
#line 153 "../src/client/logger.vala"
	g_return_if_fail (data != NULL);
#line 154 "../src/client/logger.vala"
	if (soup_log_level == SOUP_LOGGER_LOG_BODY) {
#line 154 "../src/client/logger.vala"
		_tmp0_ = g_strcmp0 (data, "") != 0;
#line 547 "logger.c"
	} else {
#line 154 "../src/client/logger.vala"
		_tmp0_ = FALSE;
#line 551 "logger.c"
	}
#line 154 "../src/client/logger.vala"
	if (_tmp0_) {
#line 155 "../src/client/logger.vala"
		cassette_client_logger_write_net_to_file (CASSETTE_CLIENT_LOGGER_BODY_OUT_PREFIX, data);
#line 557 "logger.c"
	} else {
#line 157 "../src/client/logger.vala"
		cassette_client_logger_write_net_to_file (CASSETTE_CLIENT_LOGGER_OUT_PREFIX, data);
#line 561 "logger.c"
	}
}

void
cassette_client_logger_debug (const gchar* message)
{
	CassetteClientLogLevel _tmp0_;
	CassetteClientLogLevel _tmp1_;
#line 161 "../src/client/logger.vala"
	g_return_if_fail (message != NULL);
#line 162 "../src/client/logger.vala"
	_tmp0_ = cassette_client_logger_get_log_level ();
#line 162 "../src/client/logger.vala"
	_tmp1_ = _tmp0_;
#line 162 "../src/client/logger.vala"
	if (_tmp1_ <= CASSETTE_CLIENT_LOG_LEVEL_DEBUG) {
#line 163 "../src/client/logger.vala"
		cassette_client_logger_write_to_file (CASSETTE_CLIENT_LOGGER_DEBUG_PREFIX, message);
#line 164 "../src/client/logger.vala"
		g_debug ("logger.vala:164: %s", message);
#line 582 "logger.c"
	}
}

void
cassette_client_logger_devel (const gchar* message)
{
	CassetteClientLogLevel _tmp0_;
	CassetteClientLogLevel _tmp1_;
#line 168 "../src/client/logger.vala"
	g_return_if_fail (message != NULL);
#line 169 "../src/client/logger.vala"
	_tmp0_ = cassette_client_logger_get_log_level ();
#line 169 "../src/client/logger.vala"
	_tmp1_ = _tmp0_;
#line 169 "../src/client/logger.vala"
	if (_tmp1_ <= CASSETTE_CLIENT_LOG_LEVEL_DEVEL) {
#line 599 "logger.c"
		gchar* current_time = NULL;
		GTimeZone* _tmp2_;
		GTimeZone* _tmp3_;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		FILE* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 170 "../src/client/logger.vala"
		cassette_client_logger_write_to_file (CASSETTE_CLIENT_LOGGER_DEVEL_PREFIX, message);
#line 172 "../src/client/logger.vala"
		_tmp2_ = g_time_zone_new_local ();
#line 172 "../src/client/logger.vala"
		_tmp3_ = _tmp2_;
#line 172 "../src/client/logger.vala"
		_tmp4_ = g_date_time_new_now (_tmp3_);
#line 172 "../src/client/logger.vala"
		_tmp5_ = _tmp4_;
#line 172 "../src/client/logger.vala"
		_tmp6_ = g_date_time_format (_tmp5_, "%T.%f");
#line 172 "../src/client/logger.vala"
		_tmp7_ = _tmp6_;
#line 172 "../src/client/logger.vala"
		_g_date_time_unref0 (_tmp5_);
#line 172 "../src/client/logger.vala"
		_g_time_zone_unref0 (_tmp3_);
#line 172 "../src/client/logger.vala"
		current_time = _tmp7_;
#line 173 "../src/client/logger.vala"
		_tmp8_ = stdout;
#line 173 "../src/client/logger.vala"
		_tmp9_ = current_time;
#line 173 "../src/client/logger.vala"
		_tmp10_ = g_strdup_printf ("%s : %s : %s\n", CASSETTE_CLIENT_LOGGER_DEVEL_PREFIX, _tmp9_, message);
#line 173 "../src/client/logger.vala"
		_tmp11_ = _tmp10_;
#line 173 "../src/client/logger.vala"
		fprintf (_tmp8_, "%s", _tmp11_);
#line 173 "../src/client/logger.vala"
		_g_free0 (_tmp11_);
#line 169 "../src/client/logger.vala"
		_g_free0 (current_time);
#line 645 "logger.c"
	}
}

void
cassette_client_logger_info (const gchar* message)
{
	CassetteClientLogLevel _tmp0_;
	CassetteClientLogLevel _tmp1_;
#line 181 "../src/client/logger.vala"
	g_return_if_fail (message != NULL);
#line 182 "../src/client/logger.vala"
	_tmp0_ = cassette_client_logger_get_log_level ();
#line 182 "../src/client/logger.vala"
	_tmp1_ = _tmp0_;
#line 182 "../src/client/logger.vala"
	if (_tmp1_ <= CASSETTE_CLIENT_LOG_LEVEL_USER) {
#line 183 "../src/client/logger.vala"
		cassette_client_logger_write_to_file (CASSETTE_CLIENT_LOGGER_INFO_PREFIX, message);
#line 184 "../src/client/logger.vala"
		g_info ("logger.vala:184: %s", message);
#line 666 "logger.c"
	}
}

void
cassette_client_logger_warning (const gchar* message)
{
	CassetteClientLogLevel _tmp0_;
	CassetteClientLogLevel _tmp1_;
#line 188 "../src/client/logger.vala"
	g_return_if_fail (message != NULL);
#line 189 "../src/client/logger.vala"
	_tmp0_ = cassette_client_logger_get_log_level ();
#line 189 "../src/client/logger.vala"
	_tmp1_ = _tmp0_;
#line 189 "../src/client/logger.vala"
	if (_tmp1_ <= CASSETTE_CLIENT_LOG_LEVEL_USER) {
#line 190 "../src/client/logger.vala"
		cassette_client_logger_write_to_file (CASSETTE_CLIENT_LOGGER_WARNING_PREFIX, message);
#line 191 "../src/client/logger.vala"
		g_warning ("logger.vala:191: %s", message);
#line 687 "logger.c"
	}
}

void
cassette_client_logger_error (const gchar* message)
{
	CassetteClientLogLevel _tmp0_;
	CassetteClientLogLevel _tmp1_;
#line 195 "../src/client/logger.vala"
	g_return_if_fail (message != NULL);
#line 196 "../src/client/logger.vala"
	_tmp0_ = cassette_client_logger_get_log_level ();
#line 196 "../src/client/logger.vala"
	_tmp1_ = _tmp0_;
#line 196 "../src/client/logger.vala"
	if (_tmp1_ <= CASSETTE_CLIENT_LOG_LEVEL_USER) {
#line 197 "../src/client/logger.vala"
		cassette_client_logger_write_to_file (CASSETTE_CLIENT_LOGGER_ERROR_PREFIX, message);
#line 198 "../src/client/logger.vala"
		g_error ("logger.vala:198: %s", message);
#line 708 "logger.c"
	}
}

CassetteClientLogger*
cassette_client_logger_construct (GType object_type)
{
	CassetteClientLogger* self = NULL;
#line 32 "../src/client/logger.vala"
	self = (CassetteClientLogger*) g_type_create_instance (object_type);
#line 32 "../src/client/logger.vala"
	return self;
#line 720 "logger.c"
}

CassetteClientLogger*
cassette_client_logger_new (void)
{
#line 32 "../src/client/logger.vala"
	return cassette_client_logger_construct (CASSETTE_CLIENT_TYPE_LOGGER);
#line 728 "logger.c"
}

CassetteClientLogLevel
cassette_client_logger_get_log_level (void)
{
	CassetteClientLogLevel result;
#line 49 "../src/client/logger.vala"
	result = cassette_client_logger__log_level;
#line 49 "../src/client/logger.vala"
	return result;
#line 739 "logger.c"
}

void
cassette_client_logger_set_log_level (CassetteClientLogLevel value)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 52 "../src/client/logger.vala"
	_tmp0_ = g_enum_to_string (CASSETTE_CLIENT_TYPE_LOG_LEVEL, value);
#line 52 "../src/client/logger.vala"
	_tmp1_ = g_strdup_printf ("Log level set to %s", _tmp0_);
#line 52 "../src/client/logger.vala"
	_tmp2_ = _tmp1_;
#line 52 "../src/client/logger.vala"
	cassette_client_logger_info (_tmp2_);
#line 52 "../src/client/logger.vala"
	_g_free0 (_tmp2_);
#line 52 "../src/client/logger.vala"
	_g_free0 (_tmp0_);
#line 56 "../src/client/logger.vala"
	cassette_client_logger__log_level = value;
#line 762 "logger.c"
}

GFile*
cassette_client_logger_get_log_file (void)
{
	GFile* result;
	GFile* _tmp0_;
#line 63 "../src/client/logger.vala"
	_tmp0_ = cassette_client_logger__log_file;
#line 63 "../src/client/logger.vala"
	result = _tmp0_;
#line 63 "../src/client/logger.vala"
	return result;
#line 776 "logger.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 88 "../src/client/logger.vala"
	return self ? g_object_ref (self) : NULL;
#line 784 "logger.c"
}

void
cassette_client_logger_set_log_file (GFile* value)
{
	GFile* _tmp0_;
	GFile* _tmp10_;
	GError* _inner_error0_ = NULL;
#line 66 "../src/client/logger.vala"
	_tmp0_ = cassette_client_logger__log_file;
#line 66 "../src/client/logger.vala"
	if (_tmp0_ != NULL) {
#line 797 "logger.c"
		{
			GFile* _tmp1_;
#line 68 "../src/client/logger.vala"
			_tmp1_ = cassette_client_logger__log_file;
#line 68 "../src/client/logger.vala"
			g_file_delete (_tmp1_, NULL, &_inner_error0_);
#line 68 "../src/client/logger.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 806 "logger.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp2_;
#line 67 "../src/client/logger.vala"
			e = _inner_error0_;
#line 67 "../src/client/logger.vala"
			_inner_error0_ = NULL;
#line 70 "../src/client/logger.vala"
			_tmp2_ = e;
#line 70 "../src/client/logger.vala"
			if (g_error_matches (_tmp2_, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
#line 823 "logger.c"
			}
#line 67 "../src/client/logger.vala"
			_g_error_free0 (e);
#line 827 "logger.c"
		}
		__finally0:
#line 67 "../src/client/logger.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 67 "../src/client/logger.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 67 "../src/client/logger.vala"
			g_clear_error (&_inner_error0_);
#line 67 "../src/client/logger.vala"
			return;
#line 838 "logger.c"
		}
	}
#line 74 "../src/client/logger.vala"
	if (!g_file_query_exists (value, NULL)) {
#line 843 "logger.c"
		{
			GFileOutputStream* _tmp3_;
			GFileOutputStream* _tmp4_;
#line 76 "../src/client/logger.vala"
			_tmp3_ = g_file_create (value, G_FILE_CREATE_PRIVATE, NULL, &_inner_error0_);
#line 76 "../src/client/logger.vala"
			_tmp4_ = _tmp3_;
#line 76 "../src/client/logger.vala"
			_g_object_unref0 (_tmp4_);
#line 76 "../src/client/logger.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 855 "logger.c"
				goto __catch1_g_error;
			}
#line 78 "../src/client/logger.vala"
			cassette_client_logger_info ("Logger file created");
#line 860 "logger.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp5_;
			GError* _tmp6_;
			const gchar* _tmp7_;
			gchar* _tmp8_;
			gchar* _tmp9_;
#line 75 "../src/client/logger.vala"
			e = _inner_error0_;
#line 75 "../src/client/logger.vala"
			_inner_error0_ = NULL;
#line 81 "../src/client/logger.vala"
			_tmp5_ = g_file_peek_path (value);
#line 81 "../src/client/logger.vala"
			_tmp6_ = e;
#line 81 "../src/client/logger.vala"
			_tmp7_ = _tmp6_->message;
#line 81 "../src/client/logger.vala"
			_tmp8_ = g_strdup_printf ("Can't create log file on %s. Error message: %s", _tmp5_, _tmp7_);
#line 81 "../src/client/logger.vala"
			_tmp9_ = _tmp8_;
#line 81 "../src/client/logger.vala"
			g_warning ("logger.vala:81: %s", _tmp9_);
#line 81 "../src/client/logger.vala"
			_g_free0 (_tmp9_);
#line 75 "../src/client/logger.vala"
			_g_error_free0 (e);
#line 891 "logger.c"
		}
		__finally1:
#line 75 "../src/client/logger.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 75 "../src/client/logger.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 75 "../src/client/logger.vala"
			g_clear_error (&_inner_error0_);
#line 75 "../src/client/logger.vala"
			return;
#line 902 "logger.c"
		}
	}
#line 88 "../src/client/logger.vala"
	_tmp10_ = _g_object_ref0 (value);
#line 88 "../src/client/logger.vala"
	_g_object_unref0 (cassette_client_logger__log_file);
#line 88 "../src/client/logger.vala"
	cassette_client_logger__log_file = _tmp10_;
#line 90 "../src/client/logger.vala"
	cassette_client_logger_write_to_file (CASSETTE_CLIENT_LOGGER_SYSTEM_PREFIX, NULL);
#line 91 "../src/client/logger.vala"
	cassette_client_logger_write_to_file (CASSETTE_CLIENT_LOGGER_SYSTEM_PREFIX, NULL);
#line 92 "../src/client/logger.vala"
	cassette_client_logger_write_to_file (CASSETTE_CLIENT_LOGGER_SYSTEM_PREFIX, "Log initialized");
#line 93 "../src/client/logger.vala"
	cassette_client_logger_write_to_file (CASSETTE_CLIENT_LOGGER_SYSTEM_PREFIX, NULL);
#line 919 "logger.c"
}

static void
cassette_client_value_logger_init (GValue* value)
{
#line 32 "../src/client/logger.vala"
	value->data[0].v_pointer = NULL;
#line 927 "logger.c"
}

static void
cassette_client_value_logger_free_value (GValue* value)
{
#line 32 "../src/client/logger.vala"
	if (value->data[0].v_pointer) {
#line 32 "../src/client/logger.vala"
		cassette_client_logger_unref (value->data[0].v_pointer);
#line 937 "logger.c"
	}
}

static void
cassette_client_value_logger_copy_value (const GValue* src_value,
                                         GValue* dest_value)
{
#line 32 "../src/client/logger.vala"
	if (src_value->data[0].v_pointer) {
#line 32 "../src/client/logger.vala"
		dest_value->data[0].v_pointer = cassette_client_logger_ref (src_value->data[0].v_pointer);
#line 949 "logger.c"
	} else {
#line 32 "../src/client/logger.vala"
		dest_value->data[0].v_pointer = NULL;
#line 953 "logger.c"
	}
}

static gpointer
cassette_client_value_logger_peek_pointer (const GValue* value)
{
#line 32 "../src/client/logger.vala"
	return value->data[0].v_pointer;
#line 962 "logger.c"
}

static gchar*
cassette_client_value_logger_collect_value (GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
#line 32 "../src/client/logger.vala"
	if (collect_values[0].v_pointer) {
#line 973 "logger.c"
		CassetteClientLogger * object;
		object = collect_values[0].v_pointer;
#line 32 "../src/client/logger.vala"
		if (object->parent_instance.g_class == NULL) {
#line 32 "../src/client/logger.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 980 "logger.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 32 "../src/client/logger.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 984 "logger.c"
		}
#line 32 "../src/client/logger.vala"
		value->data[0].v_pointer = cassette_client_logger_ref (object);
#line 988 "logger.c"
	} else {
#line 32 "../src/client/logger.vala"
		value->data[0].v_pointer = NULL;
#line 992 "logger.c"
	}
#line 32 "../src/client/logger.vala"
	return NULL;
#line 996 "logger.c"
}

static gchar*
cassette_client_value_logger_lcopy_value (const GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
	CassetteClientLogger ** object_p;
	object_p = collect_values[0].v_pointer;
#line 32 "../src/client/logger.vala"
	if (!object_p) {
#line 32 "../src/client/logger.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1011 "logger.c"
	}
#line 32 "../src/client/logger.vala"
	if (!value->data[0].v_pointer) {
#line 32 "../src/client/logger.vala"
		*object_p = NULL;
#line 1017 "logger.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 32 "../src/client/logger.vala"
		*object_p = value->data[0].v_pointer;
#line 1021 "logger.c"
	} else {
#line 32 "../src/client/logger.vala"
		*object_p = cassette_client_logger_ref (value->data[0].v_pointer);
#line 1025 "logger.c"
	}
#line 32 "../src/client/logger.vala"
	return NULL;
#line 1029 "logger.c"
}

GParamSpec*
cassette_client_param_spec_logger (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags)
{
	CassetteClientParamSpecLogger* spec;
#line 32 "../src/client/logger.vala"
	g_return_val_if_fail (g_type_is_a (object_type, CASSETTE_CLIENT_TYPE_LOGGER), NULL);
#line 32 "../src/client/logger.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 32 "../src/client/logger.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 32 "../src/client/logger.vala"
	return G_PARAM_SPEC (spec);
#line 1048 "logger.c"
}

gpointer
cassette_client_value_get_logger (const GValue* value)
{
#line 32 "../src/client/logger.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CASSETTE_CLIENT_TYPE_LOGGER), NULL);
#line 32 "../src/client/logger.vala"
	return value->data[0].v_pointer;
#line 1058 "logger.c"
}

void
cassette_client_value_set_logger (GValue* value,
                                  gpointer v_object)
{
	CassetteClientLogger * old;
#line 32 "../src/client/logger.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CASSETTE_CLIENT_TYPE_LOGGER));
#line 32 "../src/client/logger.vala"
	old = value->data[0].v_pointer;
#line 32 "../src/client/logger.vala"
	if (v_object) {
#line 32 "../src/client/logger.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, CASSETTE_CLIENT_TYPE_LOGGER));
#line 32 "../src/client/logger.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 32 "../src/client/logger.vala"
		value->data[0].v_pointer = v_object;
#line 32 "../src/client/logger.vala"
		cassette_client_logger_ref (value->data[0].v_pointer);
#line 1080 "logger.c"
	} else {
#line 32 "../src/client/logger.vala"
		value->data[0].v_pointer = NULL;
#line 1084 "logger.c"
	}
#line 32 "../src/client/logger.vala"
	if (old) {
#line 32 "../src/client/logger.vala"
		cassette_client_logger_unref (old);
#line 1090 "logger.c"
	}
}

void
cassette_client_value_take_logger (GValue* value,
                                   gpointer v_object)
{
	CassetteClientLogger * old;
#line 32 "../src/client/logger.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, CASSETTE_CLIENT_TYPE_LOGGER));
#line 32 "../src/client/logger.vala"
	old = value->data[0].v_pointer;
#line 32 "../src/client/logger.vala"
	if (v_object) {
#line 32 "../src/client/logger.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, CASSETTE_CLIENT_TYPE_LOGGER));
#line 32 "../src/client/logger.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 32 "../src/client/logger.vala"
		value->data[0].v_pointer = v_object;
#line 1111 "logger.c"
	} else {
#line 32 "../src/client/logger.vala"
		value->data[0].v_pointer = NULL;
#line 1115 "logger.c"
	}
#line 32 "../src/client/logger.vala"
	if (old) {
#line 32 "../src/client/logger.vala"
		cassette_client_logger_unref (old);
#line 1121 "logger.c"
	}
}

static void
cassette_client_logger_class_init (CassetteClientLoggerClass * klass,
                                   gpointer klass_data)
{
#line 32 "../src/client/logger.vala"
	cassette_client_logger_parent_class = g_type_class_peek_parent (klass);
#line 32 "../src/client/logger.vala"
	((CassetteClientLoggerClass *) klass)->finalize = cassette_client_logger_finalize;
#line 1133 "logger.c"
}

static void
cassette_client_logger_instance_init (CassetteClientLogger * self,
                                      gpointer klass)
{
#line 32 "../src/client/logger.vala"
	self->ref_count = 1;
#line 1142 "logger.c"
}

static void
cassette_client_logger_finalize (CassetteClientLogger * obj)
{
	CassetteClientLogger * self;
#line 32 "../src/client/logger.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, CASSETTE_CLIENT_TYPE_LOGGER, CassetteClientLogger);
#line 32 "../src/client/logger.vala"
	g_signal_handlers_destroy (self);
#line 1153 "logger.c"
}

 G_GNUC_NO_INLINE static GType
cassette_client_logger_get_type_once (void)
{
	static const GTypeValueTable g_define_type_value_table = { cassette_client_value_logger_init, cassette_client_value_logger_free_value, cassette_client_value_logger_copy_value, cassette_client_value_logger_peek_pointer, "p", cassette_client_value_logger_collect_value, "p", cassette_client_value_logger_lcopy_value };
	static const GTypeInfo g_define_type_info = { sizeof (CassetteClientLoggerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) cassette_client_logger_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CassetteClientLogger), 0, (GInstanceInitFunc) cassette_client_logger_instance_init, &g_define_type_value_table };
	static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
	GType cassette_client_logger_type_id;
	cassette_client_logger_type_id = g_type_register_fundamental (g_type_fundamental_next (), "CassetteClientLogger", &g_define_type_info, &g_define_type_fundamental_info, 0);
	return cassette_client_logger_type_id;
}

GType
cassette_client_logger_get_type (void)
{
	static gsize cassette_client_logger_type_id__once = 0;
	if (g_once_init_enter (&cassette_client_logger_type_id__once)) {
		GType cassette_client_logger_type_id;
		cassette_client_logger_type_id = cassette_client_logger_get_type_once ();
		g_once_init_leave (&cassette_client_logger_type_id__once, cassette_client_logger_type_id);
	}
	return cassette_client_logger_type_id__once;
}

gpointer
cassette_client_logger_ref (gpointer instance)
{
	CassetteClientLogger * self;
	self = instance;
#line 32 "../src/client/logger.vala"
	g_atomic_int_inc (&self->ref_count);
#line 32 "../src/client/logger.vala"
	return instance;
#line 1188 "logger.c"
}

void
cassette_client_logger_unref (gpointer instance)
{
	CassetteClientLogger * self;
	self = instance;
#line 32 "../src/client/logger.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 32 "../src/client/logger.vala"
		CASSETTE_CLIENT_LOGGER_GET_CLASS (self)->finalize (self);
#line 32 "../src/client/logger.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1202 "logger.c"
	}
}

